#! /bin/bash

# User must be member of "src" group

fpcroot=./fpc

git clone https://gitlab.com/freepascal.org/fpc/source.git $fpcroot

if [ "$?" != "0" ]
then
pushd $fpcroot
git stash
G_RESULT=`LANG=en_US.UTF8 git pull | grep "Already up-to-date"`
git stash pop 
popd
    if [ "$G_RESULT" != "" ]
    then
    echo $G_RESULT
    exit
    fi
fi

if [ "$?" != "0" ]
then
     echo 'Update from GIT FAILED :('
     exit
else
	echo 'Update from GIT OK :)'
	fpc -Cg -CX -XX -O4 fpcpiepatch.pas
	./fpcpiepatch
	pushd $fpcroot
	fpcmake
	make zipinstall
		if [ "$?" != "0" ]
		then
		echo 'Compiling error - update FAILED :('
		popd
		exit
		fi
	popd

fi

#git clone https://gitlab.com/freepascal.org/fpc/documentation.git $fpcroot/documentation

echo 'All OK :)'
